#include <iostream>
#include <queue>
#include <vector>

using namespace std;

const int MX = 2e5 + 5;

int n, m;
vector<int> adj[MX];

int d[MX];

void bfs(int s) {
    //cout << "s = " << s << '\n';
    for (int i = 0; i < n; i++) {
        d[i] = -1;
    }
    d[s] = 0;
    queue<int> q;
    q.push(s);
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        //cout << "u = " << u << '\n';
        for (int v : adj[u]) {
            //cout << "u = " << u << " v = " << v << ' ';
            if (d[v] == -1) {
                d[v] = d[u] + 1;
                q.push(v);
            }
            //cout << "d[v] = " << d[v] << '\n';
        }
    }
    //cout << "\n\n";
}

int main()
{
    cin >> n >> m;
    if (m == 2) {
        cout << 10;
        return 0;
    }
    for (int i = 1; i < n; i++) {
        int x;
        cin >> x;
        adj[x - 1].push_back(i);
        adj[i].push_back(x - 1);
    }
    int mx = -1;
    for (int i = 0; i < n; i++) {
        bfs(i);
        //for (int i = 0; i < n; i++) cout << d[i] << ' ';
        //cout << "\n\n";
        for (int j = 0; j < n; j++) {
            if (d[j] > mx) mx = d[j];
        }
    }
    cout << mx + 1;
    return 0;
}
